#!/usr/local/bin/ruby

def pass_here_doc(src)
  ret = true
  case src
  when /^$/
    print src
  when /^header:/, /^footer:/
    print src
    while gets
      print
      break if /^end\b/
    end
  when /^#/, /^(\w+):/, /^%(\w+)=/
    print src
  when /^%(\w+):/
    print src
    while gets
      print
      break if /^%$/
    end
  else
    ret = false
  end
  ret
end

class Format
  def initialize
    @maxcol = 65
    @col = 0
    @buf = ""
    @indent = ""
  end
  attr :buf
  attr :indent, true

  def add(s)
    @buf << s
    @col+= s.length
  end

  def line_feed
    if / $/ =~ @buf
      @buf.chop!
#     @buf << '-'
    end
    print @buf,"\n"
    @col = 0
    @buf = ""
  end

  def fix(s)
    if /^\s*$/ !~ @buf && @col + s.length > @maxcol
      line_feed
      add @indent
    end
    add s
  end

  def put_flat(flat='')
    return if flat.empty?
    flat.split.each do |word|
      if @buf.empty?
        add @indent
      else
        add ' '
      end
      if word.length == word.split(//).length
        fix word
      else
        word.scan(/(.)/) { |char,| fix char }
      end
    end
  end

end

format = Format.new

while gets
  chomp!

  next if pass_here_doc $_ + "\n"
  ~ /^ */
  format.indent = $&
  format.put_flat $'
  format.line_feed
end

print format.buf, "\n"
